<template>
  <v-layout>
    <div
      class="d-flex h-100 w-100 pt-3 pb-3 justify-content-center align-items-center"
    >
      <div class="card-main d-flex flex-column w-95 w-sm-75">
        <div
          class="d-flex ml-3 mr-3 p-3 align-items-center justify-content-start border-bottom mb-3"
        >
          <plusIcon class="icon-small-squad icon--brown" />
          <span class="text--gray font-large font-bold ml-3"
            >Cadastro de categorias</span
          >
        </div>
        <div class="d-flex ml-3 mr-3 mb-3 h-max-300">
          <input
            type="text"
            class="input input-rounded w-100 text--gray font-small"
            placeholder="Nome"
            v-model="model.name"
          />
        </div>
        <div class="d-flex ml-3 mr-3 mb-3 h-max-300">
          <treeselect
            class="p-0 m-0 bg-light w-100 text--gray font-small"
            v-model="model.pattern"
            :multiple="false"
            :options="treeselectArray"
            placeholder="Subcategoria de"
          />
        </div>
        <div class="d-flex ml-3 mr-3 mb-3 h-max-300">
          <textarea
            id="statementTemp"
            class="textarea text-area-answer input-rounded w-100 text--gray font-small"
            placeholder="Descrição"
            v-model="model.description"
          ></textarea>
        </div>
        <div class="d-flex pb-3 pt-3 ml-3 mr-3 mt-3 border-top">
          <div class="d-flex col-6 justify-content-start">
            <button
              class="btn d-flex justify-content-center bg-none p-2 pl-4 pr-4 btn text-green font-medium"
              v-on:click="cancel"
              title="Cancelar"
            >
              Cancelar
            </button>
          </div>
          <div class="d-flex col-6 justify-content-end">
            <button
              class="btn d-flex justify-content-center bg--primary p-2 pl-4 pr-4 btn text-white font-medium"
              title="Salvar instituição"
              v-on:click="save"
            >
              Salvar
            </button>
          </div>
        </div>
      </div>
    </div>
  </v-layout>
</template>
<script>
/*  ======================
 *   Cadastro de Questões
 *  ======================
 */
import VLayout from "@/layouts/Default";
import plusIcon from "@/static/icon/plus.svg";
import Category from "@/models/Category";
import categories from "@/mocks/categorias";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "login",
  data() {
    return {
      model: new Category(),
      categories: categories,
      treeselectArray: []
    };
  },
  validations: {},
  methods: {
    save() {
      const self = this;
      if (self.model.json.name) {
        console.warn(self.model.json);
        self.$router.push({
          name: "categories-list",
          params: {
            alert: {
              group: "default",
              type: "success",
              title: "Sucesso",
              text: "Categoria salva com sucesso!"
            }
          }
        });
      } else {
        self.$notify({
          group: "default",
          type: "warn",
          title: "Atenção",
          text: "O nome é obrigatório!"
        });
      }
    },
    cancel() {
      const self = this;
      self.model = new Category();
      self.$router.push({ name: "categories-list" });
    },
    mountTreeSelect(source, target) {
      source.forEach(category => {
        if (category.subcategories.length) {
          const suboptions = [];
          category.subcategories.forEach(sub => {
            suboptions.push({
              id: sub.id,
              label: sub.name
            });
          });
          target.push({
            id: category.id,
            label: category.name,
            children: suboptions
          });
        } else {
          target.push({
            id: category.id,
            label: category.name
          });
        }
      });
    }
  },
  beforeMount() {
    const self = this;
    if (self.$route.params.obj) {
      self.model.montaModel(self.$route.params.obj);
    }
    self.mountTreeSelect(self.categories, self.treeselectArray);
    console.warn(self.treeselectArray);
  },
  components: {
    VLayout,
    plusIcon,
    Treeselect
  }
};
</script>
